package cz.vsb.jtestserver.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.service.UlohaManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.*;

public class OdstranitUlohuAction extends Action {

	static Logger logger = Logger.getLogger(OdstranitUlohuAction.class);
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);
			PredmetView predmetView = (PredmetView) request.getSession()
					.getAttribute(IConstants.PREDMET_VIEW_KEY);
			int idUlohy;
			try {
				idUlohy = Integer.parseInt(request.getParameter("idUlohy"));
			} catch (NumberFormatException e) {
				logger.error(e);
				return mapping.findForward(IConstants.FAILURE_KEY);
			}
			UlohaManager man = new UlohaManager(userView);
			man.deleteUloha(idUlohy, predmetView);

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}

}
