package cz.vsb.jtestserver.action;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.PridatCviceniForm;
import cz.vsb.jtestserver.service.CviceniManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.CviceniView;
import cz.vsb.jtestserver.view.HodinaView;

public class PridatCviceniAction extends Action {
	
	static Logger logger = Logger.getLogger(PridatCviceniAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		PridatCviceniForm cvForm = (PridatCviceniForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			String idCviceniRequest = request.getParameter("idCviceni");
			if (idCviceniRequest != null) {
				// uprava
				int idCviceni;
				try {
					idCviceni = Integer.parseInt(idCviceniRequest);
				} catch (NumberFormatException e) {
					logger.error(e);
					return mapping.findForward(IConstants.FAILURE_KEY);
				}
				HodinaView hodinaView = (HodinaView) request.getSession()
						.getAttribute(IConstants.HODINA_VIEW_KEY);
				cvForm.setIdRozvrhu(hodinaView.getId());
				CviceniManager cm = new CviceniManager();
				CviceniView cv = cm.findCviceni(idCviceni);
				List<Integer> cisla = new ArrayList<Integer>(1);
				cisla.add(cv.getCisloCviceni());
				cvForm.naplnit(cv);
				cvForm.setMoznaCisla(cisla);
			} else {
				// pridani
				int idHodiny;
				try {
					idHodiny = Integer.parseInt(request.getParameter("idHodiny"));
				} catch (NumberFormatException e) {
					logger.error(e);
					return mapping.findForward(IConstants.FAILURE_KEY);
				}
				cvForm.setIdRozvrhu(idHodiny);
				CviceniManager cm = new CviceniManager();
				List<Integer> obj = cm.findVolnaCviceni(idHodiny);
				cvForm.setMoznaCisla(obj);
			}
			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}
}
