package cz.vsb.jtestserver.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.PridatUlohuForm;
import cz.vsb.jtestserver.service.UlohaManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.UserView;

public class PridatUlohuAction extends Action {
	static Logger logger = Logger.getLogger(PridatUlohuAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		PridatUlohuForm frm = (PridatUlohuForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);
			String idUlohyRequest = request.getParameter("idUlohy");
			if (idUlohyRequest != null) {
				int idUlohy;
				try {
					idUlohy = Integer.parseInt(idUlohyRequest);
				} catch (NumberFormatException e) {
					logger.error(e);
					return mapping.findForward(IConstants.FAILURE_KEY);
				}
				UlohaManager um = new UlohaManager(userView);
				frm.naplnit(um.findUloha(idUlohy));
			}
			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}

}
