package cz.vsb.jtestserver.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.PridatTestovanySouborForm;
import cz.vsb.jtestserver.service.FileNotCompiledException;
import cz.vsb.jtestserver.service.FileNotLoadedException;
import cz.vsb.jtestserver.service.FileUploadManager;
import cz.vsb.jtestserver.service.InvalidFileNameException;
import cz.vsb.jtestserver.service.UlohaManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.CviceniView;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UlohaView;
import cz.vsb.jtestserver.view.UserView;

public class SavePridatTestovanySouborAction extends Action {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws InvalidFileNameException, FileNotCompiledException,
			FileNotLoadedException {
		PridatTestovanySouborForm frm = (PridatTestovanySouborForm) form;

		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);
			PredmetView predmetView = (PredmetView) request.getSession()
					.getAttribute(IConstants.PREDMET_VIEW_KEY);
			CviceniView cviceniView = (CviceniView) request.getSession()
					.getAttribute(IConstants.CVICENI_VIEW_KEY);

			FormFile file = frm.getFile();

			Integer idUlohy = frm.getIdUlohy();
			UlohaManager um = new UlohaManager(userView);
			UlohaView ulohaView = um.findUloha(idUlohy);
			FileUploadManager fum = new FileUploadManager(userView, predmetView);
			fum.fileStudentUpload(file, cviceniView, ulohaView);
			frm.setXmlFile("/xml/" + userView.getLogin() + ".xml");

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}
}
