package cz.vsb.jtestserver.action;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.ZobrazCviceniForm;
import cz.vsb.jtestserver.service.HodinaManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.HodinaView;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UserView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

public class ZobrazCviceniAction extends Action {
	static Logger logger = Logger.getLogger(ZobrazCviceniAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		ZobrazCviceniForm frm = (ZobrazCviceniForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);
			PredmetView predmetView = (PredmetView) request.getSession()
					.getAttribute(IConstants.PREDMET_VIEW_KEY);

			int kodHodiny;
			try {
				kodHodiny = Integer.parseInt(request.getParameter("idHodiny"));
			} catch (NumberFormatException e) {
				logger.error(e);
				return mapping.findForward(IConstants.FAILURE_KEY);
			}
			HodinaManager hm = new HodinaManager();
			HodinaView hodina = hm.findHodinu(kodHodiny);
			frm.setHodina(hodina);

			HttpSession session = request.getSession(false);
			if (session != null) {
				session.invalidate();
			}
			session = request.getSession(true);
			session.setAttribute(IConstants.USER_VIEW_KEY, userView);
			session.setAttribute(IConstants.PREDMET_VIEW_KEY, predmetView);
			session.setAttribute(IConstants.HODINA_VIEW_KEY, hodina);

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}

}
