package cz.vsb.jtestserver.action;

import java.util.List;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.ZobrazCviceniDetailForm;
import cz.vsb.jtestserver.service.CviceniManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.CviceniView;
import cz.vsb.jtestserver.view.HodinaView;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UlohaView;
import cz.vsb.jtestserver.view.UserView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

public class ZobrazCviceniDetailAction extends Action {
	static Logger logger = Logger.getLogger(ZobrazCviceniDetailAction.class);
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		ZobrazCviceniDetailForm hlsform = (ZobrazCviceniDetailForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);
			PredmetView predmetView = (PredmetView) request.getSession()
					.getAttribute(IConstants.PREDMET_VIEW_KEY);
			HodinaView hodinaView = (HodinaView) request.getSession()
					.getAttribute(IConstants.HODINA_VIEW_KEY);

			int idCviceni;
			try {
				idCviceni = Integer.parseInt(request.getParameter("idCviceni"));
			} catch (NumberFormatException e) {
				logger.error(e);
				return mapping.findForward(IConstants.FAILURE_KEY);
			}
			CviceniManager cm = new CviceniManager();
			CviceniView cView = cm.findCviceni(idCviceni);
			List<UlohaView> ulohy = cm.findUlohyCviceni(idCviceni);
			String stav;
			if (cm.getOnLine(cView.getIdCviceni(), cView.getIdRozvrhu())) {
				stav = "1";
			} else {
				stav = "0";
			}

			hlsform.setOnLine(stav);
			hlsform.setCviceniView(cView);
			hlsform.setUlohy(ulohy);

			HttpSession session = request.getSession(false);
			if (session != null) {
				session.invalidate();
			}
			session = request.getSession(true);
			session.setAttribute(IConstants.USER_VIEW_KEY, userView);
			session.setAttribute(IConstants.PREDMET_VIEW_KEY, predmetView);
			session.setAttribute(IConstants.HODINA_VIEW_KEY, hodinaView);
			session.setAttribute(IConstants.CVICENI_VIEW_KEY, cView);

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}
}
