package cz.vsb.jtestserver.action;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.ZobrazitUlohuCviceniForm;
import cz.vsb.jtestserver.service.CviceniManager;
import cz.vsb.jtestserver.service.MetodaManager;
import cz.vsb.jtestserver.service.UlohaManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.CviceniView;
import cz.vsb.jtestserver.view.UserView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

public class ZobrazitUlohuCviceniAction extends Action {
	static Logger logger = Logger.getLogger(ZobrazitUlohuCviceniAction.class);
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		ZobrazitUlohuCviceniForm frm = (ZobrazitUlohuCviceniForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);
			CviceniView cviceniView = (CviceniView) request.getSession()
					.getAttribute(IConstants.CVICENI_VIEW_KEY);

			int idUlohy;
			try {
				idUlohy = Integer.parseInt(request.getParameter("idUlohy"));
			} catch (NumberFormatException e) {
				logger.error(e);
				return mapping.findForward(IConstants.FAILURE_KEY);
			}

			// zjistim zada jsou spustene testy
			CviceniManager cm = new CviceniManager();
			String stav;
			if (cm.getOnLine(cviceniView.getIdCviceni(), cviceniView
					.getIdRozvrhu())) {
				stav = "1";
			} else {
				stav = "0";
			}
			frm.setOnLine(stav);

			UlohaManager um = new UlohaManager(userView);
			frm.setUloha(um.findUloha(idUlohy));

			MetodaManager mm = new MetodaManager();
			frm.setMetody(mm.findMetody(idUlohy));

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}
}
