package cz.vsb.jtestserver.action;

import java.util.List;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.ZobrazitUlohuDetailForm;
import cz.vsb.jtestserver.service.MetodaManager;
import cz.vsb.jtestserver.service.TestyManager;
import cz.vsb.jtestserver.service.UlohaManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.TestMetodaView;
import cz.vsb.jtestserver.view.TestView;
import cz.vsb.jtestserver.view.UlohaView;
import cz.vsb.jtestserver.view.UserView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

public class ZobrazitUlohuDetailAction extends Action {
	static Logger logger = Logger.getLogger(ZobrazitUlohuDetailAction.class);
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		ZobrazitUlohuDetailForm hlsform = (ZobrazitUlohuDetailForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);

			int idUlohy;
			try {
				idUlohy = Integer.parseInt(request.getParameter("idUlohy"));
			} catch (NumberFormatException e) {
				logger.error(e);
				return mapping.findForward(IConstants.FAILURE_KEY);
			}
			UlohaManager um = new UlohaManager(userView);
			UlohaView uloha = um.findUloha(idUlohy);
			hlsform.setUloha(uloha);

			MetodaManager mm = new MetodaManager();
			hlsform.setMetody(mm.findMetody(idUlohy));

			TestyManager tm = new TestyManager();
			List<TestView> testy = tm.findTesty(idUlohy);
			List<TestMetodaView> testyMetody = tm.findMetodyTesty(testy);
			hlsform.setTesty(testy);
			hlsform.setTestyMetody(testyMetody);

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}
}
