package cz.vsb.jtestserver.form;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.util.MessageResources;
import org.apache.struts.Globals;

public class LoginForm extends ActionForm {

	private static final long serialVersionUID = 1L;

	private String login;

	private String pass;

	public LoginForm() {
		super();
		resetFields();
	}

	public ActionErrors validate(ActionMapping mapping, HttpServletRequest req ){
		ActionErrors errors = new ActionErrors();

		MessageResources resources = (MessageResources)req.getAttribute( Globals.MESSAGES_KEY );

		if(login == null || login.length() == 0) {
			String loginLabel = resources.getMessage( "label.username" );
			ActionMessage newError = new ActionMessage("global.error.login.requiredfield", loginLabel );
			errors.add(ActionMessages.GLOBAL_MESSAGE, newError);
		}

		if(pass == null || pass.length() == 0) {
			String passLabel = resources.getMessage( "label.password" );
			ActionMessage newError = new ActionMessage("global.error.login.requiredfield", passLabel );
			errors.add(ActionMessages.GLOBAL_MESSAGE, newError);
		}
			return errors;
		}

	public void reset(ActionMapping mapping, HttpServletRequest request) {
		resetFields();
	}

	protected void resetFields() {
		this.login = "";
		this.pass = "";
	}

	public void setLogin(String nbr) {
		this.login = nbr;
	}

	public String getLogin(){
		return this.login;
	}

	public String getPass() {
		return this.pass;
	}

	public void setPass(String nbr) {
		this.pass = nbr;
	}
}
