package cz.vsb.jtestserver.service;

import cz.vsb.jtestserver.util.Database;
import cz.vsb.jtestserver.view.MetodaView;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

public class MetodaManager {
	
	static Logger logger = Logger.getLogger(MetodaManager.class);

	public List<MetodaView> findMetody(int idUlohy) {
		ArrayList<MetodaView> metody = new ArrayList<MetodaView>();
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT * FROM uloha_metoda WHERE uloha = "
				+ idUlohy;
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			while (result.next()) {
				metody.add(createMetodaFormRS(result));
			}
                        result.close();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return metody;
	}

	public MetodaView findMetodu(int idMetody) {
		MetodaView metoda = null;
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT * FROM uloha_metoda WHERE id_metody = "
				+ idMetody;
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			if (result.next()) {
				metoda = createMetodaFormRS(result);
			}
                        result.close();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return metoda;
	}

	public void addMetodu(int idUlohy, String popisMetody,
			String hlavickaMetody) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "INSERT INTO uloha_metoda VALUES(null, ?, ?, ?)";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setInt(1, idUlohy);
			sql.setString(2, popisMetody);
			sql.setString(3, hlavickaMetody);
			sql.executeUpdate();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void updateMetodu(int idMetody, String popisMetody,
			String hlavickaMetody) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT * FROM uloha_metoda WHERE id_metody = "
				+ idMetody;
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			MetodaView metoda = null;
			while (result.next()) {
				metoda = createMetodaFormRS(result);
			}
                        result.close();
                        sql.close();
			metoda.setPopisMetody(popisMetody);
			metoda.setHlavickaMetody(hlavickaMetody);

			query = "UPDATE uloha_metoda SET popis_metody=? , hlavicka_metody = ? WHERE id_metody = ?";
			logger.debug(query);
			PreparedStatement sqlPrep = con.prepareStatement(query);
			sqlPrep.setString(1, popisMetody);
			sqlPrep.setString(2, hlavickaMetody);
			sqlPrep.setInt(3, idMetody);
			sqlPrep.executeUpdate();
                        sqlPrep.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void deleteMetoda(int idMetody) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "DELETE FROM uloha_metoda WHERE id_metody = ?";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setInt(1, idMetody);
			sql.executeUpdate();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	private MetodaView createMetodaFormRS(ResultSet rs) throws SQLException {
		MetodaView mView = new MetodaView();
		mView.setIdMetody(rs.getInt("id_metody"));
		mView.setUloha(rs.getInt("uloha"));
		mView.setPopisMetody(rs.getString("popis_metody"));
		mView.setHlavickaMetody(rs.getString("hlavicka_metody"));
		return mView;
	}
}
