package cz.vsb.jtestserver.service;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

/**
 * Filtr pro zajisteni spravneho kodovani prichozich dat od klienta.
 * 
 * @author M. Benes
 * 
 * @web.filter name="encoding" display-name="Request Encoding Filter"
 * 
 * @web.filter-mapping servlet-name="action"
 * 
 * @web.filter-init-param name="encoding" value="windows-1250"
 */
public class RequestEncodingFilter implements Filter {
	public void destroy() {
	}

	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {
		String encoding = selectEncoding(request);
		if (encoding != null)
			request.setCharacterEncoding(encoding);
		chain.doFilter(request, response);
	}

	public void init(FilterConfig filterConfig) throws ServletException {
		this.encoding = filterConfig.getInitParameter("encoding");
	}

	protected String selectEncoding(ServletRequest request) {
		return this.encoding;
	}

	private String encoding;
}
