package cz.vsb.jtestserver.util;

/**
 * Implementace security managera, kterou pouziva server.
 */
public class RLSecurityManager extends SecurityManager {

	public RLSecurityManager(int i) {
		limit = i;
	}

	/**
	 * Kontrola pristupu k vlaknu
	 */
	public void checkAccess(Thread thread) {
		super.checkAccess(thread);
		try {
			throw new Exception();
		} catch (Exception exception) {
			StackTraceElement astacktraceelement[] = exception.getStackTrace();
			if (astacktraceelement.length > 3
					&& astacktraceelement[4].getClassName().equals(
							"java.lang.Thread")
					&& astacktraceelement[4].getMethodName().equals("<init>")) {
				control(thread.getThreadGroup());
			}
			return;
		}
	}

	private void control(ThreadGroup threadgroup) {
		try {
			do {
				threadgroup = threadgroup.getParent();
			} while (threadgroup != null);
		} catch (SecurityException securityexception) {
			if (threadgroup.activeCount() >= limit)
				throw new SecurityException("Thread count exceeded the limit");
		}
	}

	/**
	 * Kontrola pristupu ke skupine vlaken
	 */
	public void checkAccess(ThreadGroup threadgroup) {
		super.checkAccess(threadgroup);
	}

	/**
	 * Kontrola, zda aktualni vlakno ma pravo provest ukoncene virtualniho
	 * stroje
	 */
	public void checkExit(int i) {
		//ThreadGroup threadgroup = Thread.currentThread().getThreadGroup();
		Thread.currentThread().interrupt();
		throw new SecurityException("Proces exited");
	}

	private int limit;
}
